/*
	$Id: LinkedList.c 123 2006-03-12 18:43:01Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

#include "impl/ListNode.h"
#include "impl/LinkedList.h"
#include "LinkedList.h"

union LinkedList
LinkedList_create(void)
{
    struct impl_LinkedList *impl;

    if ((impl = (struct impl_LinkedList *)malloc(sizeof(*impl))) == NULL) {
	return (union LinkedList)null;
    }
    impl->head = NULL;
#if 0
    impl->tail = NULL;
#else
    impl->next = &impl->head;
#endif
    return (union LinkedList)impl;
}

void
LinkedList_free(union LinkedList list)
{
    struct impl_LinkedList *impl = list.impl;
    struct impl_ListNode *node = impl->head, *next;

    while (node != NULL) {
	next = node->next;
	impl_ListNode_free(node);
	node = next;
    }
    free(impl);
}

int
LinkedList_append(union LinkedList list, union ListElement *e)
{
    struct impl_LinkedList *impl = list.impl;
    struct impl_ListNode *node;

    if ((node = impl_ListNode_create(e)) == NULL) {
	return -1;
    }
#if 0
    if (impl->head == NULL)
	impl->head = node;
    else
	impl->tail->next = node;
    impl->tail = node;
#else
    *(impl->next) = node;
    impl->next = &node->next;
#endif
    return 0;
}

union ListElement *
LinkedList_getFirst(union LinkedList list)
{
    struct impl_LinkedList *impl = list.impl;
    struct impl_ListNode *node = impl->head;
    union ListElement *e;

    if (node == NULL)
	return NULL;
    if ((impl->head = node->next) == NULL) {
#if 0
	impl->tail = NULL;
#else
	impl->next = &impl->head;
#endif
    }
    e = node->value;
    impl_ListNode_free(node);
    return e;
}
